package com.mvc.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TMaintenExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TMaintenExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Integer value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andMaintenIdIsNull() {
            addCriterion("MAINTEN_ID is null");
            return (Criteria) this;
        }

        public Criteria andMaintenIdIsNotNull() {
            addCriterion("MAINTEN_ID is not null");
            return (Criteria) this;
        }

        public Criteria andMaintenIdEqualTo(String value) {
            addCriterion("MAINTEN_ID =", value, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdNotEqualTo(String value) {
            addCriterion("MAINTEN_ID <>", value, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdGreaterThan(String value) {
            addCriterion("MAINTEN_ID >", value, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdGreaterThanOrEqualTo(String value) {
            addCriterion("MAINTEN_ID >=", value, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdLessThan(String value) {
            addCriterion("MAINTEN_ID <", value, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdLessThanOrEqualTo(String value) {
            addCriterion("MAINTEN_ID <=", value, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdLike(String value) {
            addCriterion("MAINTEN_ID like", value, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdNotLike(String value) {
            addCriterion("MAINTEN_ID not like", value, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdIn(List<String> values) {
            addCriterion("MAINTEN_ID in", values, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdNotIn(List<String> values) {
            addCriterion("MAINTEN_ID not in", values, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdBetween(String value1, String value2) {
            addCriterion("MAINTEN_ID between", value1, value2, "maintenId");
            return (Criteria) this;
        }

        public Criteria andMaintenIdNotBetween(String value1, String value2) {
            addCriterion("MAINTEN_ID not between", value1, value2, "maintenId");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNull() {
            addCriterion("DEVICE_SN is null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIsNotNull() {
            addCriterion("DEVICE_SN is not null");
            return (Criteria) this;
        }

        public Criteria andDeviceSnEqualTo(String value) {
            addCriterion("DEVICE_SN =", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotEqualTo(String value) {
            addCriterion("DEVICE_SN <>", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThan(String value) {
            addCriterion("DEVICE_SN >", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnGreaterThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN >=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThan(String value) {
            addCriterion("DEVICE_SN <", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLessThanOrEqualTo(String value) {
            addCriterion("DEVICE_SN <=", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnLike(String value) {
            addCriterion("DEVICE_SN like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotLike(String value) {
            addCriterion("DEVICE_SN not like", value, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnIn(List<String> values) {
            addCriterion("DEVICE_SN in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotIn(List<String> values) {
            addCriterion("DEVICE_SN not in", values, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnBetween(String value1, String value2) {
            addCriterion("DEVICE_SN between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andDeviceSnNotBetween(String value1, String value2) {
            addCriterion("DEVICE_SN not between", value1, value2, "deviceSn");
            return (Criteria) this;
        }

        public Criteria andMaintenDateIsNull() {
            addCriterion("MAINTEN_DATE is null");
            return (Criteria) this;
        }

        public Criteria andMaintenDateIsNotNull() {
            addCriterion("MAINTEN_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andMaintenDateEqualTo(Date value) {
            addCriterion("MAINTEN_DATE =", value, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateNotEqualTo(Date value) {
            addCriterion("MAINTEN_DATE <>", value, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateGreaterThan(Date value) {
            addCriterion("MAINTEN_DATE >", value, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateGreaterThanOrEqualTo(Date value) {
            addCriterion("MAINTEN_DATE >=", value, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateLessThan(Date value) {
            addCriterion("MAINTEN_DATE <", value, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateLessThanOrEqualTo(Date value) {
            addCriterion("MAINTEN_DATE <=", value, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateIn(List<Date> values) {
            addCriterion("MAINTEN_DATE in", values, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateNotIn(List<Date> values) {
            addCriterion("MAINTEN_DATE not in", values, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateBetween(Date value1, Date value2) {
            addCriterion("MAINTEN_DATE between", value1, value2, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andMaintenDateNotBetween(Date value1, Date value2) {
            addCriterion("MAINTEN_DATE not between", value1, value2, "maintenDate");
            return (Criteria) this;
        }

        public Criteria andCreateManIsNull() {
            addCriterion("CREATE_MAN is null");
            return (Criteria) this;
        }

        public Criteria andCreateManIsNotNull() {
            addCriterion("CREATE_MAN is not null");
            return (Criteria) this;
        }

        public Criteria andCreateManEqualTo(String value) {
            addCriterion("CREATE_MAN =", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManNotEqualTo(String value) {
            addCriterion("CREATE_MAN <>", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManGreaterThan(String value) {
            addCriterion("CREATE_MAN >", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_MAN >=", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManLessThan(String value) {
            addCriterion("CREATE_MAN <", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManLessThanOrEqualTo(String value) {
            addCriterion("CREATE_MAN <=", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManLike(String value) {
            addCriterion("CREATE_MAN like", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManNotLike(String value) {
            addCriterion("CREATE_MAN not like", value, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManIn(List<String> values) {
            addCriterion("CREATE_MAN in", values, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManNotIn(List<String> values) {
            addCriterion("CREATE_MAN not in", values, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManBetween(String value1, String value2) {
            addCriterion("CREATE_MAN between", value1, value2, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateManNotBetween(String value1, String value2) {
            addCriterion("CREATE_MAN not between", value1, value2, "createMan");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoIsNull() {
            addCriterion("MAINTEN_MEMO is null");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoIsNotNull() {
            addCriterion("MAINTEN_MEMO is not null");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoEqualTo(String value) {
            addCriterion("MAINTEN_MEMO =", value, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoNotEqualTo(String value) {
            addCriterion("MAINTEN_MEMO <>", value, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoGreaterThan(String value) {
            addCriterion("MAINTEN_MEMO >", value, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoGreaterThanOrEqualTo(String value) {
            addCriterion("MAINTEN_MEMO >=", value, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoLessThan(String value) {
            addCriterion("MAINTEN_MEMO <", value, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoLessThanOrEqualTo(String value) {
            addCriterion("MAINTEN_MEMO <=", value, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoLike(String value) {
            addCriterion("MAINTEN_MEMO like", value, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoNotLike(String value) {
            addCriterion("MAINTEN_MEMO not like", value, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoIn(List<String> values) {
            addCriterion("MAINTEN_MEMO in", values, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoNotIn(List<String> values) {
            addCriterion("MAINTEN_MEMO not in", values, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoBetween(String value1, String value2) {
            addCriterion("MAINTEN_MEMO between", value1, value2, "maintenMemo");
            return (Criteria) this;
        }

        public Criteria andMaintenMemoNotBetween(String value1, String value2) {
            addCriterion("MAINTEN_MEMO not between", value1, value2, "maintenMemo");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}